/*
  binforge - Repository system for Windows
  Copyright (C) 2009 Younes Serraj  Tous droits rservs.

  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la GNU General Public License telle que
  publie par la Free Software Foundation : soit la version 3 de cette
  licence, soit ( votre gr) toute version ultrieure.

  Ce programme est distribu dans lespoir quil vous sera utile, mais SANS
  AUCUNE GARANTIE : sans mme la garantie implicite de COMMERCIALISABILIT
  ni dADQUATION  UN OBJECTIF PARTICULIER. Consultez la Licence Gnrale
  Publique GNU pour plus de dtails.

  Vous devriez avoir reu une copie de la Licence Gnrale Publique GNU avec
  ce programme ; si ce nest pas le cas, consultez :
  <http://www.gnu.org/licenses/>.
*/

#ifdef BINFORGE_H
#ifndef SERVER_C
#define SERVER_C

void server_start() {
    sck_listen(1487, server_shell, true);
}

void server_shell(struct callback_params* sp) {
    char *buffer_s, *command;
    int buffer_i;

    buffer_s = (char*)malloc(sizeof(char)*SOCKET_MESSAGE_MAXLEN);
    if (buffer_s == NULL) {
        printf("Error: malloc() failed in server_shell().\n");
        sck_close(sp->s);
        free(sp);
    }

    command = sck_readln(sp->s, SOCKET_MESSAGE_MAXLEN);
    sscanf(command, "%s", buffer_s);

    if (!strcmp(buffer_s, "?EXISTS")) {
        serverAction_EXISTS(sp->s, command);
    }
    else if (!strcmp(buffer_s, "?ADD")){
        serverAction_ADD(sp->s);
    }
    else if (!strcmp(buffer_s, "?LIST")){
        serverAction_LIST(sp->s, command);
    }
    else
        sck_sendln(sp->s, "400 Bad request");

    sck_close(sp->s);

    free(sp);
    free(buffer_s);
    free(command);
}

void serverAction_EXISTS(int s, char *command) {
    char *buffer_s;
    int buffer_i;

    if ((buffer_s = mallocString(SOCKET_MESSAGE_MAXLEN)) == NULL)
        return;

    buffer_i = -1;
    sscanf(command, "%s %d", buffer_s, &buffer_i);
    if (buffer_i < 0)
        sck_sendln(s, "-Bad request.");
    else {
        sck_sendln(s, "+OK");
        if (pkg_exists(buffer_i) == false)
            sck_sendln(s, "!NO");
        else
            sck_sendln(s, "!YES");
    }
}

void serverAction_ADD(int s) {
    package *pkg;
    char *buffer_s;
    int buffer_i, i;
    FILE *fp;

    pkg = (package*)malloc(sizeof(package));
    if (pkg == NULL) {
        printf("Error: malloc() failed in serverAction_ADD().\n");
        return;
    }

    /*if ((buffer_s = mallocString(SOCKET_MESSAGE_MAXLEN)) == NULL) {
        free(pkg);
        return;
    }*/

    sck_sendln(s, "+OK");

    // NAME
    buffer_s = sck_readln(s, SOCKET_MESSAGE_MAXLEN);
    if (substrcmp(buffer_s, "NAME: ", 0) || strlen(buffer_s)<7) {
        sck_sendln(s, "-Invalid parameter");
        return;
    }
    sscanf(buffer_s, "NAME: %s", pkg->name);
    sck_sendln(s, "+OK");

    // FILENAME
    buffer_s = sck_readln(s, SOCKET_MESSAGE_MAXLEN);
    if (substrcmp(buffer_s, "FILENAME: ", 0) || strlen(buffer_s)<11) {
        sck_sendln(s, "-Invalid parameter");
        return;
    }
    strcpy(pkg->filename, right(buffer_s, strlen(buffer_s)-10));
    sck_sendln(s, "+OK");

    // VERSION
    buffer_s = sck_readln(s, SOCKET_MESSAGE_MAXLEN);
    if (substrcmp(buffer_s, "VERSION: ", 0) || strlen(buffer_s)<16) {
        sck_sendln(s, "-Invalid parameter");
        return;
    }
    sscanf(buffer_s, "VERSION: %d.%d.%d.%d",
        &pkg->version[0], &pkg->version[1], &pkg->version[2], &pkg->version[3]);
    sck_sendln(s, "+OK");

    // SIZE
    buffer_s = sck_readln(s, SOCKET_MESSAGE_MAXLEN);
    if (substrcmp(buffer_s, "SIZE: ", 0) || strlen(buffer_s)<7) {
        sck_sendln(s, "-Invalid parameter");
        return;
    }
    sscanf(buffer_s, "SIZE: %d", &pkg->size);
    sck_sendln(s, "+OK");

    // DESCRIPTION
    buffer_s = sck_readln(s, SOCKET_MESSAGE_MAXLEN);
    if (substrcmp(buffer_s, "DESCRIPTION: ", 0) || strlen(buffer_s)<14) {
        sck_sendln(s, "-Invalid parameter");
        return;
    }
    strcpy(pkg->description, right(buffer_s, strlen(buffer_s)-13));
    sck_sendln(s, "+OK");

    pkg_print(pkg, stdout);

    tmpnam(buffer_s);

    fp = fopen(buffer_s, "wb");
    if (fp == NULL) {
        printf("fopen() failed in serverAction_ADD().\n");
        free(buffer_s);
        free(pkg);
        return;
    }

    if (sck_readfile(s, pkg->size, fp) < pkg->size) {
        fclose(fp);
        remove(buffer_s);
        sck_sendln(s, "-Error in file transmition");
        free(fp);
        free(buffer_s);
        free(pkg);
        return;
    }
    else
        sck_sendln(s, "+OK");

    fclose(fp);

    if (pkg_add(pkg, buffer_s) == true) {
        sck_sendln(s, "+OK");
        printf("Package successfully added.\n");
    }
    else {
        sck_sendln(s, "-NO");
        printf("Package adding failed.\n");
    }

    remove(buffer_s);

    free(buffer_s);
    free(fp);
    free(pkg);
}

void serverAction_LIST(int s, char *command) {
    char *buffer;

    if ((buffer = mallocString(SOCKET_MESSAGE_MAXLEN)) == NULL)
        return;

    sscanf(command, "?LIST %s", buffer);

    if (!strcmp(buffer, "TXT")) {
        sck_sendln(s, "+OK");
        sck_sendln(s, "+START");
        pkgdb_list(s);
        sck_sendln(s, "+END");
    }
    /*else if (!strcmp(buffer, "BIN")) {
        sck_sendln(s, "+OK");
        sck_sendln(s, "+START");
        pkgdb_list(s);
        sck_sendln(s, "+END");
    }*/
    else
        sck_sendln(s, "-Invalid parameter");
}



#endif SERVER_C
#endif BINFORGE_H
